# coding: utf8
""" Concentration instrument module.

@author: emili

"""
from baseinstr import BaseInstrument


class ConcInstrument(BaseInstrument):
    """ Concentration instrument class.

    Parameters
    ----------
    name : str
        Name of the instrument.
    species : list od str, optional
        List of species stored in the object.

    """
    def __init__(self, name, species=None, **kwargs):
        BaseInstrument.__init__(self, name, **kwargs)
        if species is not None:
            self.nspc = len(species) # The number of measured species
            self.species = species   # The names of the measured species

    def WriteConcHeader(self):
        """ """
        subgrp = self.f[self.name].create_group("OBSERVATIONS")
        for spc in self.species:
            subgrp.create_group(spc)
