# -*- coding: utf-8 -*-
"""
MOCAGE observations class

Created on Mon Feb  6 10:29:04 2017

@author: emili
"""

from obsdb import *

if __name__ == "__main__":
    
    # ---- Examples of converters ---- 
    
    # Converters either use old ASCII files or raw data from data providers
    # They are meant to process some period of data and output hd5 files
    # To do: the loop on several dates should be done at the level of this script
    
    # Airbase example
   # plotlims = {"O3":{"max":50,"min":5},"NO2":{"max":20,"min":0},"CO":{"max":200,"min":10},"PM10":{"max":25,"min":1}}
   # for spc in ["O3","NO2","CO"]:
   # for spc in ["NO2"]:
       # MocageAscii2Hdf5("AIRBASE_Val_"+spc,"SurfConcInstrument", \
       #         DefPeriod('20100704','20100706'), \
       #         "/archive/pae/assim/OBS/AIRBASE/MOCAGE_ASCII/"+spc+"/Background_Airbase_validation-set1/2010", \
       #         "/scratch/ae/emili/seeds/obs/AIRBASE_Validation/"+spc, \
       #         makeplots=('ObsHisto','TimeSeries','ObsOnMap','ObsLoc'),\
       #         #TimeSeriesOpt={"yrange":{"max":plotlims[spc]["max"],"min":plotlims[spc]["min"]}},\
       #         PlotRegion={"LatMax":70.0,"LatMin":30.0,"LonMax":40.0,"LonMin":-20.0}, \
       #         species=[spc])
       # PlotObs("AIRBASE_"+spc,"SurfConcInstrument",\
       #         "/scratch/ae/emili/seeds/obs/AIRBASE/HDAT+20100704",\
       #         "/scratch/ae/emili/seeds/obs/AIRBASE/"+spc, \
       #         # TimeBnd=DefPeriod(start='2017103111',end='2017103112'), \
       #         makeplots=('TimeAverages',),
       #         PlotRegion={"LatMax":70.0,"LatMin":30.0,"LonMax":40.0,"LonMin":-20.0}, \
       #         MapOpt={"Resolution":'l',"AddGrid":False},\
       #         ObsOnMapOpt={"markersize":4,"colormap":"plasma",\
       #                      "range":{"max":plotlims[spc]["max"],"min":plotlims[spc]["min"]}})

    # MLS example
#    MocageAscii2Hdf5("MLS","ProfConcInstrument", \
#        DefPeriod('20100515','20110101'), \
#        "/scratch/ae/emili/o3reanl/obs/MLS/01", \
#        "/scratch/ae/emili/o3reanl/obs/MLS/01", \
#        species=['O3'],nmaxlevs=39,\
#        makeplots=('ObsLoc','AvgVertProfiles'),\
#        #PlotRegion={"LatMax":75.0,"LatMin":28.0,"LonMax":36,"LonMin":-16},\
#        #MapProjection={"type":"cyl"},MapOpt={"AddGrid":False,"Resolution":"l"},\
#        ObsLocationOpt={'markersize':10,'markercolor':'red'}, \
#        VertProfilesOpt={'xrange':{'max':1e5,'min':0.1},'yrange':{'max':0.1,'min':1.1e3},'xlog':True,'ylog':True} \
#        )
    
    # IASI example
   # Convert("IASI","IASI_L1C", \
   #         DefPeriod('20101223','20101224'), \
   #         inputdir="/archive/pae/emili/obs/IASI/downloaded/eumetsat-metop-A/L1",\
   #         outputdir="/scratch/ae/emili/o3reanl/obs/iasi-l1c/test",\
   #         #"/home/pae/emili/scratch1/o3reanl/obs/iasi-l1c/test2",\
   #         #TimeBnd=DefPeriod('2010051809','2010051812'),\
   #         #TimeBnd=DefPeriod('2010122300','2010122302'),\
   #         #LatBnd=(32.0,72.0),LonBnd=(-16.0,36.0),\
   #         LatBnd=(-85.0,85.0),\
   #         # Starts counting channels from 1, as in RTTOV
   #         # My first choice (corresponds to IASI document ozone channels)
   #         #Channels=range(1479,1672),\ 
   #         # Full spectral window used by SOFRID
   #         Channels=[i for i in range(1350,1819)],\
   #         #SaveWavelengthsIn="/wkdir/pae/emili/radiances/obs/IASI/current/channels.json",\
   #         #makeplots=(), \
   #         #makeplots=('ObsHisto','ObsLoc','NObsTimeSer','ObsOnMap','QualityFlags','ObsAux'), \
   #         makeplots=('NObsTimeSer','ObsLoc','QualityFlags','ObsAux','AvgBTSpectra','DustIndex'),\
   #         DustIndexOpt= {"range":{"min":-3,"max":0.5},"figsize":(12,12)},\
   #         AvgSpectraOpt={"range":{"ymin":0,"ymax":100}},\
   #         ObsAuxOpt={"colormap":"jet","range":{"SurfSkinTemperature":{"min":290,"max":320},"Surf2mTemperature":{"min":280,"max":310}}},\
   #         #PlotRegion={"LatMax":75.0,"LatMin":28.0,"LonMax":36,"LonMin":-16},\
   #         RemoveDust={"DustThreshold":0.5},\
   #         ClearSky={"CloudThreshold":1.0},\
   #         MapProjection={"type":"robin"})
           

    #  SO2 example
#    Convert("GOME2_SO2", "SACS_SO2",
#            DefPeriod('20110531', '20110601'),
#            "/home/pae/emili/Downloads",
#            "/home/pae/emili/Downloads",
#            species=['SO2'], nmaxlevs=60,
#            VertGridCnst = 0,
#            #TimeBnd=DefPeriod('2011053112', '2011053115'),
#            LatBnd=(32.0, 72.0), LonBnd=(-16.0, 36.0),
#            makeplots=('ObsHisto', 'ObsLoc', 'ObsOnMap'),
#            PlotRegion={"LatMax":75.0,"LatMin":40.0,"LonMax":20,"LonMin":-40},
#            # MapProjection={"type":"nsper","LatCenter":45,"LonCenter":0,"SatDist":10e3},
#            ObsOnMapOpt={}
#            )

#    Convert("IASI-SOFRID","SOFRIDProfInstrument", \
#            DefPeriod('20100701','20100702'), \
#            "/archive/pae/emili/obs/IASI/downloaded/SOFRID/v3.0/2010/07",\
#            #"/archive/pae/emili/radiances/obs/IASI-SOFRID/paper-v3.0",\
#            "/archive/pae/emili/radiances/obs/IASI-SOFRID/test",\
#            #TimeBnd=DefPeriod('2010070100','2010070103'),\
#            #LatBnd=(32.0,72.0),LonBnd=(-16.0,36.0),\
#            LatBnd=(-85.0,85.0),\
#            ClearSky={"CloudThreshold":1.0},\
#            #DataThinning={"Bounds":{"LatMax":90.0,"LatMin":-90.0,"LonMax":180.0,"LonMin":-180.0},"Resolution":{"dlon":2.0,"dlat":2.0}},\
#            #makeplots=('ObsLoc','AuxOnMap','SOFRIDAux','NObsTimeSer'),\
#            LevelsSelection=[1,4,9,14,18,21,24,30,35],\
#            #makeplots=('ObsLoc','ObsHisto','AuxOnMap','SOFRIDAux','AvgVertProfiles','AvgAuxProfiles','AvgSOFRIDL2Profiles','NObsTimeSer'),\
#            makeplots=('ObsLoc','ObsHisto','RetrievalDiags','AuxOnMap','AvgVertProfiles','AvgAuxProfiles','AvgSOFRIDL2Profiles','NObsTimeSer'),\
#            #PlotRegion={"LatMax":75.0,"LatMin":28.0,"LonMax":36,"LonMin":-16},\
#            VertProfilesOpt={'xrange':{'max':1e4,'min':-1e3},'yrange':{'max':0.1,'min':1.1e3},'xlog':True},\
#            ObsOnMapOpt= {"variables":["SurfSkinTemperature"],"figsize":(12,12),"markersize":1,"colormap":"jet",\
#                          #"Fractionnal Cover":{"range":{"max":40,"min":0}},\
#                          "Cloud Fractional Cover":{"range":{"max":20,"min":0}},\
#                          "Retrieval Cost Function":{"range":{"max":0.2,"min":0}},\
#                          "Number of Iterations":{"range":{"max":15,"min":2}},\
#                          #"L1c Quality":{"range":{"max":280,"min":0}},\
#                          "dBT_sand":{"range":{"max":0.5,"min":-3}},\
#                          "SurfSkinTemperature":{"range":{"min":280,"max":310}},\
#                          "AvkTrace":{"range":{"max":3.1,"min":2.3}}},\
#            #MapProjection={"type":"cyl"}, \
#            MapProjection={"type":"robin"}, \
#            )
    
    # GOME2 example from EUMETSAT L1B
#    Convert("GOME2","GOME2_L1B", \
#            #DefPeriod('20100707','20100708'), \
#            DefPeriod('20100915','20100916'), \
#            "/wkdir/pae/emili/obs/GOME2/downloaded/eumetsat-metop-A/2010/09", \
#            #"/space/emili/obs/downloaded/GOME2/eumetsat-metop-A/2010", \
#            "/wkdir/pae/emili/cams42/obs/GOME2/eumetsat_02",\
#            ProductName="Eumetsat",\
#            #SpectralWindow=(265,330),\
#            SpectralWindow=(265,336),\
#            ClearSky={},\
#            PositiveRad=True,\
#            #DataThinning=True,
#            SaveWavelengthsIn="/wkdir/pae/emili/cams42/obs/GOME2/eumetsat_02/wavelengths.json",\
#            #TimeBnd=DefPeriod('2010070700','2010070800'),LatBnd=(-30.0,30.0), \
#            #TimeBnd=DefPeriod('2010090710','2010090712'),\
#            #LatBnd=(32.0,72.0),LonBnd=(-16.0,36.0),\ # That was for regional test
#            makeplots=('ObsHisto','ObsLoc','GeometryHisto','ObsOnMap','AvgSpectra','NObsTimeSer'), \
#            AvgSpectraOpt={'LogScale':'log','range':{'ymin':1e-4,'ymax':1e-1}},\
#            MapProjection={"type":"robin"},MapOpt={"AddGrid":False}, \
#            #ObsLocationOpt={'markersize':3,'markercolor':'red'},
#            ObsHistoOpt={"npltsperpage":9,"spectral":{}},\
#            ObsOnMapOpt={"npltsperpage":9,"markersize":0.3,"spectral":{},"range":{"type":"FuncOfWl",\
#                                                   "WlRegions":[(265,295),(295,315),(315,338)],\
#                                                   "limits":[(1e-4,1e-5),(5e-3,5e-2),(1e-2,1e-1)]}}\
#            )       

     #GOME2 example from KNMI
#    Convert("GOME2","GOME2_L1B", \
#            DefPeriod('20100915','20100916'), \
#            # "/archive/pae/emili/obs/GOME2/downloaded/knmi/V4.50/extracted", \
#            "/archive/pae/emili/obs/GOME2/downloaded/knmi/VLast/extracted/v20190701_CAMS42/opera_nhp_hdf5/5.3-2.02-2.06", \
#            "/home/pae/emili/scratch1/cams42/obs/GOME2/L1/knmi_07",\
#            ProductName='KNMI',\
#            SpectralWindow=(265,330),\
#            ClearSky={"CloudThreshold":0.05},\
#            IncompleteSpectra={"MissingThreshold":0.10},\
#            SunZenAngle=True,\
#            #DataThinning=True,
#            #SaveWavelengthsIn="/wkdir/pae/emili/cams42/obs/GOME2/knmi_02/wavelengths.json",\
#            makeplots=('ObsHisto','ObsLoc','GeometryHisto','ObsOnMap','ObsDiags','AvgSpectra','NObsTimeSer'), \
#            AvgSpectraOpt={'LogScale':'symlog','linthreshy':1e-4,'range':{'spectra':{'min':1e-4,'max':1e-1},'relcov':{'min':1e-2,'max':1e2}},'varlist':['spectra','relcov']},\
#            MapProjection={"type":"robin"},MapOpt={"AddGrid":False}, \
#            #ObsLocationOpt={'markersize':3,'markercolor':'red'},
#            ObsDiagsOpt={"variables":["SurfAlbedo","SurfAlbedoError","TotalCloudCover"],"colormap":"jet","range":{"TotalCloudCover":{"min":0,"max":0.05},\
#                         "SurfAlbedo":{"min":0,"max":0.30},"SurfAlbedoError":{"min":0,"max":0.20}}}, \
#            ObsHistoOpt={"npltsperpage":6,"spectral":{"wavelengths":[328.9,315.18,305.04,295.01,287.77,270.1]},'varlist':['spectra','relcov']},\
#            ObsOnMapOpt={"npltsperpage":6,"markersize":4,"spectral":{"wavelengths":[328.9,315.18,305.04,295.01,287.77,270.1]},\
#                                                   "range":{"spectra":{"type":"FuncOfWl",\
#                                                   "WlRegions":[(265,295),(295,315),(315,338)],\
#                                                   "limits":[(1e-4,1e-5),(5e-3,5e-2),(1e-2,1e-1)]},\
#                                                   "relcov":{"min":0,"max":50}},\
#                                                   'varlist':['spectra','relcov']}\
#            )
    
#    Convert("GOME2-O3M","GOME2_O3M", \
#            DefPeriod('20100915','20100916'), \
##           "/archive/pae/emili/obs/GOME2/downloaded/knmi/V4.50/extracted", \
#            "/archive/pae/emili/obs/GOME2/downloaded/knmi/VLast/extracted/v20190701_CAMS42/opera_nhp_hdf5/5.3-2.02-2.06",\
#            "/home/pae/emili/scratch1/cams42/obs/GOME2/L2/testR-1debug",\
#            ClearSky={"CloudThreshold":0.05},\
#            makeplots=('ObsLoc','ObsHisto','O3MAux','ObsOnMap','AvgVertProfiles','NObsTimeSer','AvgAuxProfiles','AuxOnMap'),\
#            LevelsSelection=[1,4,9,14,18,21,24,30,35],\
#            #PressBnd={'min':10,'max':101000},\
#            #AvkPressBnd={'min':10,'max':101000},\
#            VertProfilesOpt={'xrange':{'max':1e2,'min':1e-4},'yrange':{'max':1e-3,'min':1.1e3},'xlog':True},\
#            #AuxProfilesOpt={'avkrange':{'max':0.3,'min':-0.2},'covrange':{'max':1e2,'min':1e-4,'xlog':True},'yrange':{'max':1e-3,'min':1.1e3}},\
#            AuxProfilesOpt={'avkrange':{'max':0.3,'min':-0.2},'covrange':{'max':1e2,'min':1e-3,'xlog':True},'yrange':{'max':1e-3,'min':1.1e3}},\
#            ObsOnMapOpt= {"figsize":(15,15),"markersize":1,\
#                          "CloudFraction":{"range":{"max":0.05,"min":0}},\
#                          "AvkTrace":{"range":{"max":3.1,"min":2.3}},\
#                          },\
#            MapProjection={"type":"robin"}, \
#            )

    # Radiosoundings example
#    MocageAscii2Hdf5("WOUDC","RadioSondeInstrument", \
#        DefPeriod('20100705','20100708'), \
#        "/wkdir/pae/emili/wkdir_pae1/OBS/OZONE/SONDES/DATA_ON_MOC60NIV", \
#        "/wkdir/pae/emili/radiances/obs/RADIOSONDES/MOCAGE60NIV", \
#        species=['O3'],nmaxlevs=60)

   # Convert("WOUDC","RadioSondeInstrument", \
   #     DefPeriod('20100101','20110101'), \
   #     # DefPeriod('20100915','20100916'), \
   #     "/scratch/ae/emili/toar2/obs/sondes/woudc/downloaded", \
   #     "/scratch/ae/emili/toar2/obs/sondes/woudc/02", \
   #     # "/scratch/ae/emili/toar2/obs/sondes/hegiftom/ftp-me.oma.be/upload", \
   #     # "/scratch/ae/emili/toar2/obs/sondes/hegiftom/03", \
   #     # LatBnd=(-89.5,89.5), \
   #     # writeNC=True, \
   #     # provider="HEGIFTOM", \
   #     provider="WOUDC", \
   #     species=['O3'],nmaxlevs=43,ConvertOpt={'PressureGrid':True},\
   #     makeplots=('ObsLoc','AvgVertProfiles','VertProfiles'), \
   #     # makeplots=('ObsLoc','AvgVertProfiles'), \
   #     #LatBnd=(32.0,72.0),LonBnd=(-16.0,36.0),\
   #     #MapProjection={"type":"cyl"},MapOpt={"AddGrid":False,"Resolution":"l"},\
   #     ObsLocationOpt={'markersize':10,'markercolor':'red'}, \
   #     #PlotRegion={"LatMax":75.0,"LatMin":28.0,"LonMax":36,"LonMin":-16},\
   #     VertProfilesOpt={'xrange':{'max':1e4,'min':1},'yrange':{'max':1,'min':1.1e3},'xlog':True})
   
# VIIRS files from Calum

    # Convert("VIIRS","VIIRS_AOD",
    #         DefPeriod('20200601','20200602'),
    #         "/home/eemili/data/viirs/1x1",
    #         '/home/eemili/data/viirs/1x1/plots',
    #         wavelength=[550],
    #         makeplots=('ObsLoc','ObsHisto','ObsOnMap'),
    #         ObsOnMapOpt={'range':{'min':0,'max':2}}
    #         ) 
    
    # Convert("VIIRS","VIIRS_AOD",
    #     DefPeriod('20240115','20240116'),
    #     #"/esarchive/scratch/cmeikle/Projects/data/VIIRS/obsfinal/regional-bdrc-0.1x0.1_test/3hourly/centered",
    #     #"/esarchive/scratch/cmeikle/Projects/data/VIIRS/obsfinal/noaa20/global/3hourly/centered",
    #     #"/esarchive/scratch/cmeikle/Projects/data/VIIRS/obsfinal/noaa20/regional/hourly/centered",
    #     "/esarchive/scratch/eemili/obs/viirs/noaa20/namee",
    #     '/esarchive/scratch/eemili/obs/viirs/noaa20/namee/plots',
    #     wavelength=[550],
    #     #rotated=True,cenlon=20,cenlat=35,
    #     makeplots=('ObsLoc','ObsHisto','ObsOnMap'),
    #     ObsOnMapOpt={'range':{'min':0,'max':2},'markersize':0.5},
    #     ObsLocationOpt={'markersize':0.5}
    #     )
    
    PlotObs("VIIRS","VIIRS_AOD",
            '/esarchive/scratch/eemili/obs/viirs/noaa20/namee/plots/HDAT+20240114',
            outputdir="/esarchive/scratch/eemili/obs/viirs/noaa20/namee/plots",
            makeplots=('ObsLoc','ObsOnMap'),
            TimeBnd=DefPeriod('2024011411','2024011414'),
            PlotRegion={"LatMax":50.0,"LatMin":-0.0,"LonMax":60,"LonMin":-30},
            ObsOnMapOpt={'range':{'min':0,'max':2},'markersize':0.5},
            ObsLocationOpt={'marker':'.','markersize':0.2})

# SLTSR files from Calum

    # Convert("SLSTR","VIIRS_AOD",
    #     DefPeriod('20200602','20200603'),
    #     "/esarchive/scratch/ekarnezi/CMUG_project/obsfinal/dust",
    #     '/home/eemili/data/SLSTR',
    #     wavelength=[550],
    #     makeplots=('ObsLoc','ObsHisto','ObsOnMap'),
    #     ObsOnMapOpt={'range':{'min':0,'max':2},'markersize':0.5}
    #     )
    
    # PlotObs("SLSTR","VIIRS_AOD",
    #         '/home/eemili/data/SLSTR/HDAT+20200601',
    #         outputdir="/home/eemili/data/SLSTR/plots",
    #         ObsOnMapOpt={'range':{'min':0,'max':1.0}})
    
    # PlotObsTimeSeries("SLSTR","VIIRS_AOD",
    #         '/home/eemili/data/SLSTR',
    #         TimeBnd=DefPeriod('20200601','20200603'),
    #         outputdir="/home/eemili/data/SLSTR/plots-timeser",
    #         AvgTimeSerFreq=3,
    #         ObsOnMapOpt={'range':{'min':0,'max':1.0}})

    # Old SOFRID L2 data example
#    MocageAscii2Hdf5("IASI-SOFRID","IntQtyInstrument", \
#        DefPeriod('20100707','20100708'), \
#        "/wkdir/pae/assim/wkdir_pae2/OBS/MACCIII/IASI_O3_SOFRID/MOCAGE_ASCII_D01", \
#        "/wkdir/pae/emili/radiances/obs/IASI-SOFRID/TOC-newconverter", \
#        species=['O3'],nmaxlevs=43)

#   AOD example from Matthieu

#    d1, d2 = DefPeriod('20110520', '20110521')
#    MocageAscii2Hdf5("MODIS","AODInstrument",(d1,d2),"/home/pae/emili/tmp","/home/pae/emili/tmp",wavelength=[550])    

    # AOD MODIS - see user_instruments/MODIS_AOD_instr.py
    # repin = ["/cnrm/plasma/Data/MODIS/MOD04_L2/2018/136",
    #          "/cnrm/plasma/Data/MODIS/MYD04_L2/2018/136"]
    # repout = "./"
    # d1, d2 = DefPeriod('20180419', '20180426')
    # days = [d for d in daterange(d1, d2)]
    # print(days)
    # for i in range(len(days)-1):
    #     print(i)
    #     Convert(
    #         "MODIS", "MODIS_AOD",
    #         (days[i], days[i+1]),
    #         repin, repout,
    #         wavelength=[550],
    #         Qflag=3,  # Quality Flag
    #         # DataThinning={"Resolution": {"dlon": 1.0, "dlat": 1.0},
    #         #               "obsperbox": 2},
    #         # VertGridCnst=0,
    #         # TimeBnd=DefPeriod('2011053112', '2011053115'),
    #         # LatBnd=(32.0, 72.0), LonBnd=(-16.0, 36.0),
    #         # makeplots=('ObsHisto', 'ObsLoc', 'ObsOnMap'),
    #         # PlotRegion={"LatMax": 75.0, "LatMin": 40.0,
    #         #             "LonMax": 20, "LonMin": -40},
    #         # MapProjection={"type": "nsper", "LatCenter": 45,
    #         #                "LonCenter": 0, "SatDist":10e3},
    #         # ObsOnMapOpt={},
    #         make_super_obs={'resolution': .2},
    #         )

    # MSG Ash - see user-instruments/MSGashEUMETSAT_IntQty_instr.py
    # repin = ["/cnrm/comets/Data/EUMETSAT_ash/20181224/",
    #          "/cnrm/comets/Data/EUMETSAT_ash/20181225/"]
    # repout = "./"
    
    # d1, d2 = DefPeriod('20181224', '20181227')
    # days = [d for d in daterange(d1, d2)]
    # # print(days)
    # for i in range(len(days)-1):
    #     print(i)
    #     Convert(
    #         "MSG", "MSGashEUMETSAT",
    #         (days[i], days[i+1]),
    #         repin, repout,
    #         THRmask={"thr": 1.0},  # Threshold on ash column
    #         # Directory where to find the latitude-longitude of MSG disk
    #         lldir={"lldir": "/cnrm/comets/Data/EUMETSAT_ash/"},
    #         # DataThinning={"Resolution": {"dlon": 1.0, "dlat": 1.0}},
    #         )

    # #  AOD PMAP
    # repin = ["/cnrm/comets/Data/EUMETSAT_PMAP/20190222-20190224/"]
    # repout = "./"
    # d1, d2 = DefPeriod('20190223', '20190226')
    # days = [d for d in daterange(d1, d2)]
    # print(days)
    # for i in range(len(days)-1):
    #     print(i)
    #     Convert(
    #         "PMAP", "PMAP_AOD",
    #         (days[i], days[i+1]),
    #         repin, repout,
    #         wavelength=[550],
    #         Qflag=0,  # Quality Flag - we keep obs below or equal this value
    #         # DataThinning={"Resolution": {"dlon": 1.0, "dlat": 1.0},
    #         #               "obsperbox": 2},
    #         # VertGridCnst=0,
    #         # TimeBnd=DefPeriod('2011053112', '2011053115'),
    #         # LatBnd=(32.0, 72.0), LonBnd=(-16.0, 36.0),
    #         # makeplots=('ObsHisto', 'ObsLoc', 'ObsOnMap'),
    #         # PlotRegion={"LatMax": 75.0, "LatMin": 40.0,
    #         #             "LonMax": 20, "LonMin": -40},
    #         # MapProjection={"type":"nsper", "LatCenter":45,
    #         #                "LonCenter":0, "SatDist":10e3},
    #         # ObsOnMapOpt={}
    #         )
    
    # # EARLINET lidar
    # data_path = ("/cnrm/plasma/Users/bigeard/EUNADICS/DATA/EARLINET/" +
    #              "earlinet_eyja2010/profiles_clean")
    # Convert(
    #     instrname="EARLINET",
    #     instrtype="EarlinetLidar",
    #     period=(datetime.date(2010, 5, 4), datetime.date(2010, 5, 5)),
    #     inputdir=data_path,
    #     outputdir="./",
    #     wavelength=532,
    #     nmaxlevs=3000)
    
    # # CALIOP lidar
    # data_path = ("/cnrm/plasma/Users/frebourgn/OBSERVATIONS/ObsLidar/" +
    #              "CAL_LID_L2_05kmAPro-Standard/2017/2017_02_22/")
    # Convert(
    #     instrname="CALIOP",
    #     instrtype="CaliopLidar",
    #     period=(datetime.date(2017, 2, 22), datetime.date(2017, 2, 23)),
    #     inputdir=data_path,
    #     prefix="CAL_LID_L2_05kmAPro-Standard-V4-10",
    #     outputdir="./",
    #     dset_name='Extinction_Coefficient_532',
    #     wavelength='532',
    #     wllist=['532'],
    #     vertical_levels=[
    #         35000, 40000, 45000, 50000, 55000, 60000, 64000, 68000,
    #         72000, 76000, 80000, 83500, 87000, 90000, 92500, 95000,
    #         97000, 99000, 100000, 101000, 102000],
    #     minVert=2,
    #     )
    
    # # eprofile
    # repin = "/cnrm/plasma/Users/frebourgn/OBSERVATIONS/Lidar_Lille/LR_50"
    # repout = "./"
    
    # Convert(
    #     instrname="Lidar_Lille",
    #     instrtype="EprofileLidar",
    #     period=DefPeriod('20171015', '20171018'),
    #     inputdir=repin,
    #     outputdir=repout,
    #     file_name="BALI-L2_{date}T00-00-00_Meteo-France-Lille-5030_V1-00.nc",
    #     wavelength=532,
    #     dset_name="Extinction_Coefficient_532nm",
    #     vert_name='Altitude',
    #     time_name='Time',
    #     lat_name='Latitude',
    #     lon_name='Longitude',
    #     date_format='%Y-%m-%d',
    #     minVert=2,
    #     vertical_levels=[
    #         0, 41, 124, 247, 409, 609, 846, 1121, 1431, 1778, 
    #         2153,  2585, 3045, 3547, 4089, 4674, 5305, 5935, 6717, 7505,
    #         8293, 9079, 9868, 10506, 11445, 12229, 13018, 13806, 14595, 15379,
    #         16164, 16948, 17748, 18530, 19331, 20123, 20907, 21694, 22489, 23252,
    #         24047, 24833, 25639, 26391, 27210, 27941, 28767, 30000],
    #     )
    
    # EEA surface observations
    # plotlims = {"O3":{"max":50,"min":5},"NO2":{"max":20,"min":0},"CO":{"max":200,"min":10},
    #             "PM10":{"max":25,"min":1},"PM2.5":{"max":15,"min":1},"SO2":{"max":10,"min":0}}
    
    # for spe in ['PM2.5', 'NO2', 'PM10', 'O3', 'SO2', 'CO']:
    #     Convert(
    #         instrname='AIRBASE_{}'.format(spe),
    #         instrtype="EeaSurfaceObservations",
    #         period=DefPeriod('20231003', '20231004'),
    #         inputdir="/esarchive/obs/meteofrance/eionet-cams2_40/original_files",
    #         outputdir="/home/eemili/scripts/scratch/"+spe,
    #         minutesToSubtractToTime=30,
    #         make_super_obs={'resolution': .2},
    #         # station_types_file="area_types_2018.txt",
    #         species=spe)
        
    # for spe in ['PM2.5', 'NO2', 'PM10', 'O3', 'SO2', 'CO']:
    #     PlotObs("AIRBASE_"+spe,"SurfConcInstrument",\
    #         "/home/eemili/scripts/scratch/"+spe+"/HDAT+20231003.h5",\
    #         "/home/eemili/scripts/scratch/"+spe, \
    #         makeplots=('ObsHisto','TimeSeries','ObsOnMap','ObsLoc'),
    #         PlotRegion={"LatMax":70.0,"LatMin":30.0,"LonMax":40.0,"LonMin":-20.0}, \
    #         MapOpt={"Resolution":'l',"AddGrid":False},\
    #         ObsOnMapOpt={"markersize":4,"colormap":"plasma",\
    #                       "range":{"max":plotlims[spe]["max"],"min":plotlims[spe]["min"]}})
        
    # AggregateInstr(
    #     ["/home/eemili/scripts/scratch/"+spe for spe in ['O3', 'NO2', 'PM10', 'PM2.5','SO2', 'CO']],
    #     outdir="/home/eemili/scripts/scratch",
    #     filefreq="daily")
    
    # # TROPOMI
    # data_path = "/cnrm/comets/Users/lamotte/TROPOMI"
    # Convert(
    #     instrname="TROPOMI_SO2",
    #     instrtype="TropomiInstr",
    #     period=(datetime.date(2018, 12, 24), datetime.date(2018, 12, 25)),
    #     inputdir=data_path,
    #     outputdir="./",
    #     nmaxlevs=34,
    #     qflag=.5,
    #     detect_flag=1,
    #     representative_height=7,
    #     )
