# -*- coding: utf-8 -*-
"""
MOCAGE observations class

Created on Mon Feb  6 10:29:04 2017

@author: emili
"""

import obsdb

if __name__ == "__main__":
    
    # ---- Example of data preprocessing ----

    obsdb.Convert("HEGIFTOM","RadioSondeInstrument", \
       # dobs.DefPeriod('20100101','20110101'), \
       obsdb.DefPeriod('20100915','20100918'), \
       # "/scratch/ae/emili/toar2/obs/sondes/woudc/downloaded", \
       # "/scratch/ae/emili/toar2/obs/sondes/woudc/02", \
       "/archive/pae/emili/toar2/obs/sondes/hegiftom/ftp-me.oma.be/upload", \
       "./output/ozonesondes", \
       # LatBnd=(-89.5,89.5), \
       writeNC=True, \
       provider="HEGIFTOM", \
       # provider="WOUDC", \
       species=['O3'],nmaxlevs=43,ConvertOpt={'PressureGrid':True},\
       makeplots=('ObsLoc','AvgVertProfiles','VertProfiles'), \
       # makeplots=('ObsLoc','AvgVertProfiles'), \
       #LatBnd=(32.0,72.0),LonBnd=(-16.0,36.0),\
       #MapProjection={"type":"cyl"},MapOpt={"AddGrid":False,"Resolution":"l"},\
       ObsLocationOpt={'markersize':10,'markercolor':'red'}, \
       #PlotRegion={"LatMax":75.0,"LatMin":28.0,"LonMax":36,"LonMin":-16},\
       VertProfilesOpt={'xrange':{'max':1e4,'min':1},'yrange':{'max':1,'min':1.1e3},'xlog':True})

    # Radiosoundings nc conversion
    # obsdb.PreProcessObs("WOUDC","RadioSondeInstrument", \
    #     dobs.DefPeriod('20100101','20110101'), \
    #     "/scratch/ae/emili/toar2/obs/sondes/woudc/02", \
    #     "/scratch/ae/emili/toar2/obs/sondes/woudc/02/ncdf", \
    #     species=['O3'],nmaxlevs=43,
    #     writeNC=True, \
    #     # makeplots=('ObsLoc','AvgVertProfiles','VertProfiles'), \
    #     #LatBnd=(32.0,72.0),LonBnd=(-16.0,36.0),\
    #     #MapProjection={"type":"cyl"},MapOpt={"AddGrid":False,"Resolution":"l"},\
    #     ObsLocationOpt={'markersize':10,'markercolor':'red'}, \
    #     #PlotRegion={"LatMax":75.0,"LatMin":28.0,"LonMax":36,"LonMin":-16},\
    #     VertProfilesOpt={'xrange':{'max':1e4,'min':1},'yrange':{'max':1,'min':1.1e3},'xlog':True})

    # Plot some statistics from netcdf ozonesondes data
    # obsdb.PlotObs("WOUDC","RadioSondeInstrument",\
    #     "./input/HDAT+20100915.nc", \
    #     "./output/plots", \
    #     makeplots=('ObsLoc','AvgVertProfiles','VertProfiles'), \
    #     #LatBnd=(32.0,72.0),LonBnd=(-16.0,36.0),\
    #     #MapProjection={"type":"cyl"},MapOpt={"AddGrid":False,"Resolution":"l"},\
    #     ObsLocationOpt={'markersize':10,'markercolor':'red'}, \
    #     #PlotRegion={"LatMax":75.0,"LatMin":28.0,"LonMax":36,"LonMin":-16},\
    #     VertProfilesOpt={'xrange':{'max':1e4,'min':1},'yrange':{'max':1,'min':1.1e3},'xlog':True} \
    #     )

    # obsdb.PlotObsTimeSeries("TOAR2SURF","SurfConcInstrument",\
    #     "/archive/pae/emili/toar2/obs/surface",\
    #     "/archive/pae/emili/toar2/obs/surface/plots", \
    #     TimeBnd=DefPeriod('2010120100','2011010100'), \
    #     makestats=True, \
    #     makeplots=['ObsHisto','TimeAverages'], \
    #     # PlotRegion={"LatMax":75.0,"LatMin":28.0,"LonMax":36,"LonMin":-16},\
    #     MapProjection={"type":"cyl"},MapOpt={"AddGrid":False,"Resolution":"l"},\
    #     #ObsLocationOpt={'markersize':2,'markercolor':'red'}, \
    #     ObsOnMapOpt= {"markersize":2,"colormap":"YlOrRd","range":{"max":80,"min":10}} \
    #     )

    # Conversion from TOAR2 nc to mocage hdf
    # obsdb.PreProcessObs("TOAR2SURF","SurfConcInstrument",\
    #     dobs.DefPeriod('2010010100','2011010100'),\
    #     "/archive/pae/emili/toar2/obs/surface",\
    #     "/archive/pae/emili/toar2/obs/surface/hdf"
    #     # makeplots=('ObsLoc','AvgVertProfiles'), \
    #     # ObsLocationOpt={'markersize':10,'markercolor':'red'}, \
    #     )

    # Aggregators
    # obsdb.AggregateNcdf(["/scratch/ae/emili/toar2/obs/sondes/hegiftom/03/ncdf/HDAT+20100915.nc",
    #            "/scratch/ae/emili/toar2/obs/sondes/woudc/02/ncdf/HDAT+20100915.nc"],
    #           "/scratch/ae/emili/toar2/obs/sondes/merged/01/ncdf/HDAT+20100915.nc")

    # obsdb.AggregateInstr(['/archive/pae/emili/toar2/obs/sondes/hegiftom/03/ncdf',\
    #                    '/archive/pae/emili/toar2/obs/sondes/woudc/02/ncdf',
    #                    '/archive/pae/emili/toar2/obs/surface'],\
    #                   outdir='/archive/pae/emili/toar2/obs/merged/2010', \
    #                   filefreq="daily",filetype='nc')

    # obsdb.AggregateInstr(['/archive/pae/emili/toar2/obs/sondes/hegiftom/03',\
    #                    '/archive/pae/emili/toar2/obs/sondes/woudc/02',\
    #                    '/archive/pae/emili/toar2/obs/surface/hdf'],\
    #                   outdir='/archive/pae/emili/toar2/obs/merged/2010', \
    #                   filefreq="daily")

