# je@bsc-es. translated form Monarch-NMMB and preproc fortran codes from Z. Janjic.  
import numpy as np

def rotate_geo_to_rot(geo_lat_in,geo_lon_in, tlm0d , tph0d, wbd, sbd ,invalid, checkbounds = False):
  #
  #model_configure_file =
  #model_configure_file = optdicts['general']['model_configure_file']
  geo_lat =np.atleast_2d(geo_lat_in).astype('float')
  geo_lon = np.atleast_2d(geo_lon_in).astype('float')
  #mcf = readraw.readconfigfile(model_configure_file,  nohead = True)
  dtr=np.pi/180.
  rtd=180./np.pi
  xlon = geo_lon
  xlat = geo_lat
  #tlm0d = float(mcf.get('root','tlm0d'))
  #tph0d = float(mcf.get('root','tph0d'))
  tph0=tph0d*dtr #!rad of the centre lat
  ctph0=np.cos(tph0) #!cos of the centre lat
  stph0=np.sin(tph0) #!sin of the centre lat
  tlm, tph  = tll(xlon,xlat,tlm0d,dtr,ctph0,stph0)
  rlon=tlm*rtd
  rlat=tph*rtd
  #obsout = 0
  if checkbounds:
    #wbd = float(mcf.get('root','wbd'))
    #sbd = float(mcf.get('root','sbd'))
    bcw=np.abs(wbd)
    bcs=np.abs(sbd)
    #obsout=1
    #obsout=np.ones(rlon.shape)
    b_0 = np.logical_and(  np.abs(rlon) < np.abs(bcw) , np.abs(rlat)<np.abs(bcs)  )
    #obsout[b_0] = 0
    #if ((np.abs(rlon) < np.abs(bcw)) and (np.abs(rlat)<np.abs(bcs))) :
    #  obsout=0
    rlat[~b_0] = invalid
    rlon[~b_0] = invalid
  rlat = rlat.squeeze()
  rlon = rlon.squeeze()
  #if obsout == 0:
  return rlat,rlon
  #else:
  #  return invalid,invalid
# from fortran : 

def tll(xlon,xlat,tlm0d,dtr,ctph0,stph0):
# from f90 version: 
#!     ****************************************************************
#!     *                                                              *
#!     *  programer: z. janjic, shmz, feb. 1981                       *
#!     *  ammended:  z. janjic, ncep, jan. 1996                       *
#!     *                                                              *
#!     *  transformation from lat-lon to rotated lat-lon coordinates  *
#!     ****************************************************************
#!     ****************************************************************
#!     *  tlm   - transformed longitude, degs.                         *
#!     *  tph   - transformed latitude, degs.                          *
#!     *  tlm0d - the angle of rotation of the transformed lat-lon    *
#!     *          system in the longitudinal direction, degs          *
#!     *  ctph0 - cos(tph0), tph0 is the angle of rotation of the     *
#!     *          transformed lat-lon systemn in the latitudinal      *
#!     *          direction, precomputed                              *
#!     *  stph0 - sin(tph0), tph0 is the angle of rotation of the     *
#!     *          transformed lat-lon systemn in the latitudinal      *
#!     *          direction, precomputed                              *
#!     *  almd  - geographical longitude, degs, range -180.,180       *
#!     *  aphd  - geographical latitude,  degs, range - 90., 90.,     *
#!     *          poles are singular                                  *
#!     ****************************************************************
  relm=(xlon-tlm0d)*dtr #!distance from the centre lon (in rad)
  srlm=np.sin(relm) #!sin of this distance
  crlm=np.cos(relm) #!cos of this distance
  aph=xlat*dtr #!lat in rad 
  sph=np.sin(aph) #!sin of lat
  cph=np.cos(aph) #!cos of lat
  cc=cph*crlm #!cos of lat times cos of lon distance
  anum=cph*srlm #!cos of lat times sin of lon distance
  denom=ctph0*cc+stph0*sph #!cos of the centre lat times cc plus sin of the centre lat times sin of lat
#!
  tlm=np.arctan2(anum,denom)
  tph=np.arcsin(ctph0*sph-stph0*cc)
#!
  return tlm, tph
#      endsubroutine tll

#      endsubroutine tll
def rotate_rot_to_geo(rlat_in,rlon_in, tlm0d , tph0d, wbd, sbd ,invalid, checkbounds = False):
  rlat=np.atleast_2d(rlat_in)
  rlon=np.atleast_2d(rlon_in)
  dtr=np.pi/180.
  rtd=180./np.pi
  tlm = rlon*dtr
  tph = rlat*dtr
  tph0=tph0d*dtr #!rad of the centre lat
  ctph0=np.cos(tph0) #!cos of the centre lat
  stph0=np.sin(tph0) #!sin of the centre lat
  almd , aphd = rtll(tlm,tph,tlm0d,ctph0,stph0)
  return aphd, almd


def rtll(tlm_in,tph_in,tlm0d,ctph0,stph0) :
#      subroutine rtll(tlm,tph,tlm0d,ctph0,stph0,almd,aphd)
#!     ****************************************************************
#!     *                                                              *
#!     *  programer: z. janjic, shmz, feb. 1981                       *
#!     *  ammended:  z. janjic, ncep, jan. 1996                       *
#!     *                                                              *
#!     *  transformation from rotated lat-lon to lat-lon coordinates  *
#!     ****************************************************************
#!     ****************************************************************
#!     *  tlm   - transformed longitude, rad.                         *
#!     *  tph   - transformed latitude, rad.                          *
#!     *  tlm0d - the angle of rotation of the transformed lat-lon    *
#!     *          system in the longitudinal direction, degs          *
#!     *  ctph0 - cos(tph0), tph0 is the angle of rotation of the     *
#!     *          transformed lat-lon systemn in the latitudinal      *
#!     *          direction, precomputed                              *
#!     *  stph0 - sin(tph0), tph0 is the angle of rotation of the     *
#!     *          transformed lat-lon systemn in the latitudinal      *
#!     *          direction, precomputed                              *
#!     *  almd  - geographical longitude, degs, range -180.,180       *
#!     *  aphd  - geographical latitude,  degs, range - 90., 90.,     *
#!     *          poles are singular                                  *
#!     ****************************************************************
#!
#      parameter(pi=3.1415927,dtr=pi/180.)
  tlm = np.atleast_2d(tlm_in)
  tph = np.atleast_2d(tph_in)
  pi = np.pi
  dtr=pi/180.
#!
  stlm=np.sin(tlm)
  ctlm=np.cos(tlm)
  stph=np.sin(tph)
  ctph=np.cos(tph)
#!
  sph=ctph0*stph+stph0*ctph*ctlm
  sph=np.minimum(sph,1.)
  sph=np.maximum(sph,-1.)
  #aph=asin(sph)
  aph=np.arcsin(sph)
  aphd=aph/dtr
  anum=ctph*stlm
  denom=(ctlm*ctph-stph0*sph)/ctph0
  #relm=atan2(anum,denom)-pi
  relm=np.arctan2(anum,denom)#-pi # THIS pi is written in some of the nmonarch preproc code! but not in other places..
  almd=relm/dtr+tlm0d
#
  almd[almd >  180.] = almd[almd >  180.]-360.
  almd[almd < -180.] = almd[almd < -180.]+360.

  #if(almd >  180.): 
  #  almd=almd-360.
  #if(almd < -180.) : 
  #  almd=almd+360.
  return almd.squeeze(axis=0), aphd.squeeze(axis=0) #EE why this 2d transform?
  # return almd, aphd
#      endsubroutine rtll


#!
#      subroutine lltorll ( old_lat, old_lon, ref_lat, ref_lon, new_lat, new_lon)
def lltorll ( old_lat, old_lon, ref_lat, ref_lon) :
#      implicit none
#      real old_lat, old_lon, ref_lat, ref_lon, new_lat, new_lon
#      real lat_a, lat_b, lon_a, lon_b, sin_lat, arg_a, arg_b, arg_c, dtr

#     ! dtr = degrees to radians PI / 180.0
  #dtr = 4.D0*DATAN(1.D0) / 180.0
  dtr = np.pi / 180.0
  lat_a = old_lat * dtr
  lat_b = ref_lat * dtr
  lon_a = old_lon * dtr
  lon_b = ref_lon * dtr
  arg_a = np.cos(lat_b) * np.sin(lat_a) + np.sin(lat_b) * np.cos(lat_a) * np.cos(lon_a)
  arg_b = np.cos(lat_a)*np.sin(lon_a)
  sin_lat = np.cos(lon_b)*np.sin(lat_a)+np.sin(lat_b)*np.cos(lat_a)*np.cos(lon_a)
  if( sin_lat <-1.0) :  sin_lat =-1.0
  if( sin_lat > 1.0) :  sin_lat = 1.0
  arg_c = (np.cos(lat_a)*np.cos(lon_a)-np.sin(lat_b)*sin_lat) / np.cos(lat_b)
  new_lat = np.arcsin(arg_a) / dtr
  new_lon = np.arctan2(arg_b, arg_c) / dtr + ref_lon
  if(new_lon > 180.0) : new_lon = new_lon - 360.0
  if(new_lon < -180.0) : new_lon = new_lon + 360.0
  return new_lat, new_lon
#      end subroutine
#!   





